import type { DurableObject } from "cloudflare:workers";
import { type SnapshotPolicy } from "./index.js";
type FieldDecoratorFactoryReturn<T> = (value: T, metadata: {
    kind: string;
    name: string;
}) => FieldDecoratorReturn<T>;
type FieldDecoratorReturn<T> = (this: DurableObject, initialValue: T) => T;
type DiffableOpts = {
    name?: string;
    snapshotPolicy?: SnapshotPolicy;
};
export declare function diffable(_: any, { kind, name }: {
    kind: string;
    name: string;
}): FieldDecoratorReturn<any>;
export declare function diffable(name?: string): FieldDecoratorFactoryReturn<any>;
export declare function diffable(options: DiffableOpts): FieldDecoratorFactoryReturn<any>;
export {};
